/*
 *  ******************************************************************************
 *  *
 *  *
 *  * This program and the accompanying materials are made available under the
 *  * terms of the Apache License, Version 2.0 which is available at
 *  * https://www.apache.org/licenses/LICENSE-2.0.
 *  *
 *  *  See the NOTICE file distributed with this work for additional
 *  *  information regarding copyright ownership.
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 *  * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 *  * License for the specific language governing permissions and limitations
 *  * under the License.
 *  *
 *  * SPDX-License-Identifier: Apache-2.0
 *  *****************************************************************************
 */

package org.nd4j.linalg.heartbeat.reports;

import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
public class Task {
    public enum NetworkType {
        MultilayerNetwork, ComputationalGraph, DenseNetwork
    }

    public enum ArchitectureType {
        CONVOLUTION, RECURRENT, RBM, WORDVECTORS, UNKNOWN
    }

    private NetworkType networkType;
    private ArchitectureType architectureType;

    private int numFeatures;
    private int numLabels;
    private int numSamples;

    public String toCompactString() {

        String builder = "F: " + numFeatures + "/" +
                "L: " + numLabels + "/" +
                "S: " + numSamples + " ";

        return builder;
    }
}
